<?php
if ( ! class_exists( 'Solar_Panel_Distributor_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Solar_Panel_Distributor_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Solar_Panel_Distributor_Plugin_Activation_WPElemento_Importer {

        private static $solar_panel_distributor_instance;
        public $solar_panel_distributor_action_count;
        public $solar_panel_distributor_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$solar_panel_distributor_instance) ) {
            self::$solar_panel_distributor_instance = new self();
          }
          return self::$solar_panel_distributor_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'solar_panel_distributor_recommended_plugins', array($this, 'solar_panel_distributor_recommended_elemento_importer_plugins_array') );

            $solar_panel_distributor_actions                   = $this->solar_panel_distributor_get_recommended_actions();
            $this->solar_panel_distributor_action_count        = $solar_panel_distributor_actions['count'];
            $this->solar_panel_distributor_recommended_actions = $solar_panel_distributor_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function solar_panel_distributor_recommended_elemento_importer_plugins_array($solar_panel_distributor_plugins){
            $solar_panel_distributor_plugins[] = array(
                    'name'     => esc_html__('Mizan Demo Importor', 'solar-panel-distributor'),
                    'slug'     =>  'mizan-demo-importer',
                    'function' => 'Mizan_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the Mizan Demo Importor plugin for importing the demo content with Elementor.', 'solar-panel-distributor'),               
            );
            return $solar_panel_distributor_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'solar-panel-distributor-plugin-activation-script', esc_url(get_template_directory_uri()) . '/inc/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('solar-panel-distributor-plugin-activation-script', 'solar_panel_distributor_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'solar-panel-distributor'),
                    'activating' => esc_html__('Activating', 'solar-panel-distributor'),
                    'error' => esc_html__('Error', 'solar-panel-distributor'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=mizan-demo-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=mizandemoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'solar-panel-distributor-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function solar_panel_distributor_get_recommended_actions() {

            $solar_panel_distributor_act_count  = 0;
            $solar_panel_distributor_actions_todo = get_option( 'recommending_actions', array());

            $solar_panel_distributor_plugins = $this->solar_panel_distributor_get_recommended_plugins();

            if ($solar_panel_distributor_plugins) {
                foreach ($solar_panel_distributor_plugins as $solar_panel_distributor_key => $solar_panel_distributor_plugin) {
                    $solar_panel_distributor_action = array();
                    if (!isset($solar_panel_distributor_plugin['slug'])) {
                        continue;
                    }

                    $solar_panel_distributor_action['id']   = 'install_' . $solar_panel_distributor_plugin['slug'];
                    $solar_panel_distributor_action['desc'] = '';
                    if (isset($solar_panel_distributor_plugin['desc'])) {
                        $solar_panel_distributor_action['desc'] = $solar_panel_distributor_plugin['desc'];
                    }

                    $solar_panel_distributor_action['name'] = '';
                    if (isset($solar_panel_distributor_plugin['name'])) {
                        $solar_panel_distributor_action['title'] = $solar_panel_distributor_plugin['name'];
                    }

                    $solar_panel_distributor_link_and_is_done  = $this->solar_panel_distributor_get_plugin_buttion($solar_panel_distributor_plugin['slug'], $solar_panel_distributor_plugin['name'], $solar_panel_distributor_plugin['function']);
                    $solar_panel_distributor_action['link']    = $solar_panel_distributor_link_and_is_done['button'];
                    $solar_panel_distributor_action['is_done'] = $solar_panel_distributor_link_and_is_done['done'];
                    if (!$solar_panel_distributor_action['is_done'] && (!isset($solar_panel_distributor_actions_todo[$solar_panel_distributor_action['id']]) || !$solar_panel_distributor_actions_todo[$solar_panel_distributor_action['id']])) {
                        $solar_panel_distributor_act_count++;
                    }
                    $solar_panel_distributor_recommended_actions[] = $solar_panel_distributor_action;
                    $solar_panel_distributor_actions_todo[]        = array('id' => $solar_panel_distributor_action['id'], 'watch' => true);
                }
                return array('count' => $solar_panel_distributor_act_count, 'actions' => $solar_panel_distributor_recommended_actions);
            }

        }

        public function solar_panel_distributor_get_recommended_plugins() {

            $solar_panel_distributor_plugins = apply_filters('solar_panel_distributor_recommended_plugins', array());
            return $solar_panel_distributor_plugins;
        }

        public function solar_panel_distributor_get_plugin_buttion($slug, $name, $function) {
                $solar_panel_distributor_is_done      = false;
                $solar_panel_distributor_button_html  = '';
                $solar_panel_distributor_is_installed = $this->is_plugin_installed($slug);
                $solar_panel_distributor_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $solar_panel_distributor_is_activeted = (class_exists($function)) ? true : false;
                if (!$solar_panel_distributor_is_installed) {
                    $solar_panel_distributor_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $solar_panel_distributor_plugin_install_url = wp_nonce_url($solar_panel_distributor_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $solar_panel_distributor_button_html        = sprintf('<a class="solar-panel-distributor-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($solar_panel_distributor_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'solar-panel-distributor'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'solar-panel-distributor')
                    );
                } elseif ($solar_panel_distributor_is_installed && !$solar_panel_distributor_is_activeted) {

                    $solar_panel_distributor_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($solar_panel_distributor_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $solar_panel_distributor_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $solar_panel_distributor_button_html = sprintf('<a class="solar-panel-distributor-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($solar_panel_distributor_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'solar-panel-distributor'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'solar-panel-distributor')
                    );
                } elseif ($solar_panel_distributor_is_activeted) {
                    $solar_panel_distributor_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'solar-panel-distributor'));
                    $solar_panel_distributor_is_done     = true;
                }

                return array('done' => $solar_panel_distributor_is_done, 'button' => $solar_panel_distributor_button_html);
            }
        public function is_plugin_installed($slug) {
            $solar_panel_distributor_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $solar_panel_distributor_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($solar_panel_distributor_installed_plugins[$solar_panel_distributor_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $solar_panel_distributor_keys = array_keys($this->get_installed_plugins());
            foreach ($solar_panel_distributor_keys as $solar_panel_distributor_key) {
                if (preg_match('|^' . $slug . '/|', $solar_panel_distributor_key)) {
                    return $solar_panel_distributor_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Solar_Panel_Distributor_Plugin_Activation_WPElemento_Importer::get_instance();